﻿using EduSpider.Model.Entity;
using EduSpider.Repository;
using EduSpider.Utility;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Text;
using VTX.FW.Helper;

namespace EduSpider.Spiders.ClassInRule
{
    public class StudentManager
    {
        public async void RunAsync(string cookie)
        {
            var request = Utility.HttpHelper.GenerateHttp(cookie);
            int pageIndex = 1, pageCount = 1, pageSize=10000;

            while (pageIndex <= pageCount) 
            {
                var paramStr = $"page={pageIndex}&perpage={pageSize}&isdel=0";
                var content = new StringContent(paramStr, System.Text.Encoding.UTF8, "application/x-www-form-urlencoded");
                var response = await request.PostAsync("https://console.eeo.cn/saasajax/student.ajax.php?action=getSchoolStudentListByPage", content);

                var resultStr = response.Content.ReadAsStringAsync().Result ?? string.Empty;
                var result = new JObject();
                if (result.TryFromString(resultStr))
                {
                    var data = (result.ContainsKey("data") ? result["data"] : new JObject()) as JObject;
                    if (data.ContainsKey("totalStudentNum")) {
                        #region 更新PageCount

                        if (pageIndex == 1)
                        {
                            pageCount = (int)Math.Ceiling(data.GetDecimal("totalStudentNum") / pageSize);
                        }

                        #endregion
                        var students = JsonConvert.DeserializeObject<RB_Student>(data.GetString("studentList"));
                    }
                }
            }

        }

        /// <summary>
        /// 获取课程列表
        /// </summary>
        public async void RunCourse(string cookie)
        {
            var request = Utility.HttpHelper.GenerateHttp(cookie);
            var paramStr = "page=1&perpage=20&courseState=1";
            var content = new StringContent(paramStr, System.Text.Encoding.UTF8, "application/x-www-form-urlencoded");
            var response = await request.PostAsync("https://console.eeo.cn/saasajax/course.ajax.php?action=getCourseList", content);

            var result = response.Content.ReadAsStringAsync().Result;
            List<RB_Course> list = new();
            if (!string.IsNullOrWhiteSpace(result))
            {
                JObject rootObj = JObject.Parse(result);
                if (!string.IsNullOrWhiteSpace(rootObj.GetString("data")))
                {
                    JObject dataObj = JObject.Parse(rootObj.GetString("data"));
                    var totalNum = dataObj.GetInt("totalCourseNum");
                    JArray courseArray = JArray.Parse(dataObj.GetString("courseList"));
                    if (courseArray != null && courseArray.Count > 0)
                    {
                        foreach (var jItem in courseArray)
                        {
                            JObject courseObj = JObject.Parse(jItem.ToString());
                            list.Add(new RB_Course()
                            {
                                courseId = courseObj.GetInt("courseId"),
                                courseName=courseObj.GetString("courseName"),
                                beginTime=courseObj.GetInt("beginTime"),

                            });
                        }
                    }
                }
            }
            ICourseRepository courseRepository = new CourseRepository();
            courseRepository.BatchSetCourse(list);
            Console.WriteLine("result", result);
        }


    }
}
